package wood.keith.opentools.wizards.jsptags;

/**
 * Encapsulate details about a function within a JSP tag library.
 *
 * @author   Keith Wood
 * @version  3.0  10 February 2004 - JSP 2.0
 */
public class TaglibDescriptorFunction extends TaglibDescriptorElement {

	// Internal variables
  private String _name;
  private String _functionClass = "";
  private String _functionSig = "";
  private String _example = "";

	/**
	 * Build a new taglib function.
	 *
	 * @param  name  the name of the function in a tag library
	 */
	public TaglibDescriptorFunction(String name) {
		super();
		setName(name);
	}

	private void setName(String value) { _name = value; }

	public String getName() { return _name; }

  public void setFunctionClass(String value) { _functionClass = value; }

  public String getFunctionClass() { return _functionClass; }

  public void setFunctionSig(String value) { _functionSig = value; }

  public String getFunctionSig() { return _functionSig; }

  public void setExample(String value) { _example = value; }

  public String getExample() { return _example; }

	public String toString() { return getName(); }

	/**
	 * Format the function for inclusion in a taglib descriptor file.
	 *
   * @param  jspVersion  the version of JSP in use
	 * @return  the function definition in XML
	 */
	public String toXml(String jspVersion) {
    StringBuffer buffer = new StringBuffer("\n  <function>\n");
    addDescriptionGroup(buffer, "    ");
    addXmlElement(buffer, "name", getName(), "    ");
    addXmlElement(buffer, "function-class", getFunctionClass(), "    ");
    addXmlElement(buffer, "function-signature", getFunctionSig(), "    ");
    addXmlElement(buffer, "example", getExample(), "    ");
    buffer.append("  </function>\n");
    return buffer.toString();
	}
}
