package wood.keith.opentools.wizards.jsptags;

/**
 * Encapsulate details about a listener within a JSP tag library.
 *
 * @author   Keith Wood
 * @version  3.0  10 February 2004 - JSP 2.0
 */
public class TaglibDescriptorListener extends TaglibDescriptorElement {

	// Internal variables
  private String _className;

  /**
   * Create a new listener entry.
   * 
   * @param  className    the name of the listener class
   * @param  description  its description
   */
	public TaglibDescriptorListener(String className, String description) {
		_className = className;
    setDescription(description);
	}

	public String getClassName() { return _className; }

	public String toString() { return getClassName(); }

  /**
   * Format the listener for inclusion in a taglib descriptor file.
   *
   * @param  jspVersion  the version of JSP in use
   * @return  the listener definition in XML
   */
  public String toXml(String jspVersion) {
    StringBuffer buffer = new StringBuffer("\n  <listener>\n");
    if (jspVersion.equals(JSPTagProperties.JSP_20)) {
      addDescriptionGroup(buffer, "    ");
    }
    addXmlElement(buffer, "listener-class", getClassName(), "    ");
    buffer.append("  </listener>\n");
    return buffer.toString();
  }
}
