package wood.keith.opentools.wizards.jsptags;

/**
 * Encapsulate details about a tag file within a JSP tag library.
 *
 * @author   Keith Wood
 * @version  3.0  10 February 2004 - JSP 2.0
 */
public class TaglibDescriptorTagFile extends TaglibDescriptorElement {

	// Internal variables
  private String _name;
  private String _path;
  private String _example = "";

	/**
	 * Build a new tag file reference.
	 *
	 * @param  name  the action name for the tag
	 * @param  path  the path to this file
	 */
	public TaglibDescriptorTagFile(String name, String path) {
		super();
		setName(name);
		setPath(path);
	}

	private void setName(String value) { _name = value; }

	public String getName() { return _name; }

	public void setPath(String value) { _path = value; }

	public String getPath() { return _path; }

	public void setExample(String value) { _example = value; }

	public String getExample() { return _example; }

	public String toString() { return getName(); }

	/**
	 * Format the tag file for inclusion in a taglib descriptor file.
	 *
   * @param  jspVersion  the version of JSP in use
	 * @return  the tag file definition in XML
	 */
	public String toXml(String jspVersion) {
		StringBuffer buffer = new StringBuffer("\n  <tag-file>\n");
    addDescriptionGroup(buffer, "    ");
		addXmlElement(buffer, "name", getName(), "    ");
    addXmlElement(buffer, "path", getPath(), "    ");
  	addXmlElement(buffer, "example", getExample(), "    ");
		buffer.append("  </tag-file>\n");
		return buffer.toString();
	}
}
